#include <stdio.h>

void print_board(char *board) {
    for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 3; j++) {
            printf("%c ", *(board + i * 3 + j));
        }
        printf("\n");
    }
}

int check_winner(char *board) {
    for (int i = 0; i < 3; i++) {
        if (*(board + i * 3) == *(board + i * 3 + 1) && *(board + i * 3 + 1) == *(board + i * 3 + 2) && *(board + i * 3) != ' ')
            return 1;
        if (*(board + i) == *(board + i + 3) && *(board + i + 3) == *(board + i + 6) && *(board + i) != ' ')
            return 1;
    }
    if (*(board) == *(board + 4) && *(board + 4) == *(board + 8) && *(board) != ' ') return 1;
    if (*(board + 2) == *(board + 4) && *(board + 4) == *(board + 6) && *(board + 2) != ' ') return 1;
    return 0;
}

int main() {
    char board[3][3] = {
        {' ', ' ', ' '},
        {' ', ' ', ' '},
        {' ', ' ', ' '}
    };
    int player = 1, moves = 0;

    while (moves < 9) {
        print_board(&board[0][0]);
        int x, y;
        printf("Player %d, enter row and column (0-2): ", player);
        scanf("%d %d", &x, &y);
        // Check if the input is within bounds
        if (x < 0 || x > 2 || y < 0 || y > 2) {
            printf("Invalid input. Please enter row and column between 0 and 2.\n");
            continue;
        }

        // Check if the cell is already occupied
        if (board[x][y] == ' ') {
            board[x][y] = (player == 1) ? 'X' : 'O';
            if (check_winner(&board[0][0])) {
                print_board(&board[0][0]);
                printf("Player %d wins!\n", player);
                return 0;
            }
            player = 3 - player;  // Switch player
            moves++;
        } else {
            printf("Cell already occupied. Try again.\n");
        }
    }
    printf("It's a draw!\n");
    return 0;
}
